﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PW007CoughRecognize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            LstDp = new List<DataPoint>();
            DoubleBuffered = true;
        }

        private List<DataPoint> LstDp;

        Graphics g;

        bool bIsMouseDown = false, bIsStart = true;

        Point ptStart, ptEnd;

        private DateTime dt = DateTime.Now;

        private DateTime dt2 = DateTime.Now;

        List<Point> LstPt = new List<Point>();

        List<CoughState> LstCS = new List<CoughState>();

        List<DataPoint> LstDwn = new List<DataPoint>();

        List<DataPoint> LstPtTop = new List<DataPoint>();

        double h = 0;

        private void Form1_Load(object sender, EventArgs e)
        {
            g = plPaint.CreateGraphics();
            h = plPaint.Height;
        }

        private void plPaint_MouseMove(object sender, MouseEventArgs e)
        {

            if (bIsMouseDown)
            {
                ptEnd = e.Location;

                if ((DateTime.Now - dt2).TotalMilliseconds > 1000)
                {
                    plPaint.Refresh();

                }
            }
        }

        private void plPaint_MouseDown(object sender, MouseEventArgs e)
        {

            if (bIsStart)
            {

                ptStart = e.Location;

                bIsStart = false;

                LstDp.Add(CreateByPoint(ptStart));
            }

            bIsMouseDown = true;
        }

        double addMi = 1;

        private DataPoint CreateByPoint(Point pt)
        {

            DataPoint dp = new DataPoint();

            dp.CurrentTime = dt.AddSeconds(addMi);

            addMi++;

            dp.Val = (int)Convert(pt);

            dp.pt = pt;

            return dp;

        }



        private void plPaint_Paint(object sender, PaintEventArgs e)
        {

            if (LstPt.Count > 1)
            {

                e.Graphics.DrawLines(Pens.Red, LstPt.ToArray());

                Font font = new Font("宋体", 9);

                for (int i = 0; i < LstPt.Count; i++)
                {
                    g.DrawString(Convert(LstPt[i]).ToString(), font, Brushes.Red, LstPt[i]);
                }
                font.Dispose();
            }
            e.Graphics.DrawLine(Pens.Red, ptStart, ptEnd);
        }



        bool bStartIsUp = true;

        bool bIsScanStart = false;

        int iSIndex = 0;

        List<DataPoint> LstTop = new List<DataPoint>();

        const int iDeadTime = 6;
        double avgDiff = 0;
        private void btnRecognize_Click(object sender, EventArgs e)
        {
         
            Recognize();
            //double val = GetAmplitude(LstDp);
            //avgDiff = val * 0.6;
            //DoDealPt(LstPtTop);

            return;
        }



        private bool ChargeIsStartUp(int iStartIdex, List<DataPoint> list)
        {

            var nextD = list[iStartIdex + 1];

            var d1 = list[iStartIdex];

            if (nextD.Val - d1.Val < 0)
            {

                bStartIsUp = false;

            }
            else
            {

                bStartIsUp = true;
            }

            return bStartIsUp;

        }



        private void btnClearPaint_Click(object sender, EventArgs e)
        {

            LstDp.Clear();

            LstCS.Clear();

            LstPt.Clear();

            LstTop.Clear();

            g.Clear(plPaint.BackColor);

            bIsStart = true;

            LstDwn.Clear();

            LstPtTop.Clear();

            LstDealed.Clear();

            addMi = 1;

        }



        private void plPaint_MouseUp(object sender, MouseEventArgs e)
        {

            Font font = new Font("宋体", 9);

            LstPt.Add(ptStart);

            LstPt.Add(ptEnd);

            LstDp.Add(CreateByPoint(ptEnd));

            bIsMouseDown = false;

            ptEnd = e.Location;

            ptStart = ptEnd;

            font.Dispose();

        }



        private double Convert(Point pt)
        {

            double dd = (pt.Y - h);

            return Math.Abs(dd);

        }

        List<DataPoint> LstDealed = new List<DataPoint>();

        private void DoDealPt(List<DataPoint> lst)
        {

            Font font = new Font("宋体", 12);



            DataPoint pt1 = null, pt2 = null;

            List<DataPoint> lstTep = new List<DataPoint>();

            for (int j = 0; j < lst.Count; j++)
            {

                pt1 = lst[j];

                lstTep.Add(pt1);

                for (int i = j + 1; i < lst.Count; i++)
                {

                    pt2 = lst[i];

                    if (Math.Abs(pt1.Val - pt2.Val) > avgDiff)
                    {

                        //lstTep.Add(pt2);

                        continue;

                    }
                    else
                    {

                        lstTep.Add(pt2);

                        j = i - 1;

                        break;

                    }
                }

                if (lstTep.Count > 2)
                {

                    for (int m = 0; m < lstTep.Count - 1; m++)
                    {

                        LstDealed.Add(lstTep[m]);

                    }

                }
                else if (lstTep.Count == 2)
                {

                    if ((lstTep[1].CurrentTime - lstTep[0].CurrentTime).TotalSeconds > iDeadTime)
                    {

                        LstDealed.AddRange(lstTep);

                    }
                    else
                    {

                        LstCS.Add(new CoughState(lstTep[0], lstTep[1]));

                    }

                }

                lstTep.Clear();
            }

            foreach (var item in LstDealed)
            {

                lst.Remove(item);

            }

            for (int i = 0; i < LstCS.Count; i++)
            {

                g.DrawLine(Pens.Red, LstCS[i].DpEnd.pt, LstCS[i].DpStart.pt);

                g.DrawString("开始", font, Brushes.DarkBlue, LstCS[i].DpStart.pt);

                g.DrawString("结束", font, Brushes.DarkBlue, LstCS[i].DpEnd.pt);

            }
            font.Dispose();
        }

        private void Recognize()
        {

            Font font = new Font("宋体", 10);

            if (LstDp.Count < 2)
            {
                return;
            }

            bIsScanStart = true;

            DataPoint dpDown = null;

            for (int i = 1; i < LstDp.Count; i++)
            {

                if (bIsScanStart)
                {

                    iSIndex = i - 1;

                    bStartIsUp = ChargeIsStartUp(iSIndex, LstDp);

                    dpDown = LstDp[iSIndex];

                    bIsScanStart = false;
                }

                var dS = LstDp[i - 1];

                var dNext = LstDp[i];

                int topIndex = 0;

                if (bStartIsUp)//开始是上升的
                {

                    while (i + 1 < LstDp.Count)
                    {

                        dS = LstDp[i];

                        dNext = LstDp[i + 1];

                        ++i;

                        if (dNext.Val - dS.Val < 0)//到达峰顶dS
                        {

                            LstPtTop.Add(dS);

                            topIndex = LstPtTop.Count - 1;
                            break;

                        }

                    }

                }

                else
                {
                    LstPtTop.Add(dpDown);
                    topIndex = LstPtTop.Count - 1;
                }

                DataPoint temp = LstPtTop[topIndex];

                int j = i + 1;

                while (j < LstDp.Count)
                {

                    var dTopNext = LstDp[j];

                    var dTopS = LstDp[j - 1];

                    j++;

                    if (dTopNext.Val - dTopS.Val > 0)//峰谷dTops
                    {

                        LstDwn.Add(dTopS);
                        bIsScanStart = true;
                        break;
                    }

                    else
                    {

                        continue;

                    }
                }

                i = j - 1;

                if (i == LstDp.Count() - 1)
                {
                    if (LstDp[i].Val - LstDp[i - 1].Val > 0)
                    {
                        LstPtTop.Add(LstDp[i]);
                    }
                }
            }
            for (int i = 0; i < LstPtTop.Count; i++)
            {

                g.DrawString("峰顶", font, Brushes.Blue, new Point(LstPtTop[i].pt.X,LstPtTop[i].pt.Y-10));

            }

            for (int i = 0; i < LstDwn.Count; i++)
            {

                g.DrawString("峰谷", font, Brushes.DarkGreen, new Point(LstDwn[i].pt.X, LstDwn[i].pt.Y + 5));

            }
        }
    
        /// <summary>
        /// 获取峰谷平均差值
        /// </summary>
        /// <returns></returns>
        private double GetAmplitude(List<DataPoint> lst)
        {
            int[] toPValArr = new int[LstPtTop.Count];
            int[] downValArr = new int[LstDwn.Count];

            for (int i = 0; i < LstPtTop.Count; i++)
            {
                toPValArr[i] = LstPtTop[i].Val;
            }
            for (int i = 0; i < LstDwn.Count; i++)
            {
                downValArr[i] = LstDwn[i].Val;
            }

            Array.Sort(toPValArr);
            Array.Sort(downValArr);

            var sumTop = toPValArr.Sum() - toPValArr[toPValArr.Length - 1];
            var sumDown = downValArr.Sum() - downValArr[0];

            return (sumTop * 1.0 / (toPValArr.Length - 1)) - (sumDown * 1.0 / (downValArr.Length - 1));
        }
    }
}
